///////////////////////////////////////////////
// Copyright
///////////////////////////////////////////////
//
// Example of the textfx4 library
// Copyright (c) 2001 Jari Komppa
//
//
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
// 
//
///////////////////////////////////////////////
#include <windows.h>
#include "textfx4.h"
#include "fliflc.h"

void demomain()
{
    TFX_BlockColor bc;
    TFX_AsciiArt aa;
    bc.BuildLUT();
    aa.BuildLUT();
    TFX_SetTitle("FLI player in textmode");
    FliAnimation *a=new FliAnimation("lodju.flc",0);
    a->renderframe();
    a->renderframe();
    a->renderframe();
    int * pal=new int[256];
    int * fb=new int[160*100];
    for (int i=0;i<256;i++)
        pal[i]=((a->mPalette[i*3+0]&0xff)<<2)+
               ((a->mPalette[i*3+1]&0xff)<<10)+
               ((a->mPalette[i*3+2]&0xff)<<18);
    unsigned int tick=GetTickCount();
    while(1)
    {
        while (tick>=GetTickCount()) {};
        tick+=(1000/25);

        a->renderframe();
        for (int i=0;i<160*100;i++)
            fb[i]=pal[a->mFramebuffer[i]&0xff];
        aa.Dump2x(fb,TFXQuad(0,0,160,100),160);
        bc.Dump4x(fb,TFXQuad(0,0,160,100),160,0,25);
        TFX_Present();
    }
}